$(function() {
    // cache DOM elements
    var cacheDom = function(dict) {
        for (var id in dict) {
            dict[id].element = $(document.getElementById(id));
        }
    };
    cacheDom(searchIndex.parents);
    cacheDom(searchIndex.children);

    makeZebra();

    $('div.haschildren').click(function() {
        var next = $(this).parent().next();

        var li = $(this).parent();
        var closed = true;
        closed = li.is('.closed');
        if (li.is('.closed')) {
            li.removeClass('closed').addClass('open');
        } else {
            li.removeClass('open').addClass('closed');
        }

        while (next.length != 0 && !next.is('.parentitem')) {
            next.toggle();
            next = next.next();
        }

        makeZebra();
    });

    var restoreInitialVisibility = function(elementDict) {
        for (var id in elementDict) {
            var element = elementDict[id];
            var initialState = element.initialState;

            if (initialState === true) {
                element.element.show();
            } else {
                element.element.hide();
            }

            element.initialState = undefined;
        }
    }

    $('#search').keyup(function() {
        var query = $.trim($(this).val()).toLowerCase();

        if (query.length == 0) {
            for (var parentId in searchIndex.parents) {
                var parent = searchIndex.parents[parentId];

                var anyChildVisible = false;

                for (var i in parent.children) {
                    var childId = parent.children[i];
                    var child = searchIndex.children[childId];

                    anyChildVisible = anyChildVisible || child.initialState === true;
                }

                if (anyChildVisible) {
                    parent.element.removeClass('closed').addClass('open');
                } else {
                    parent.element.removeClass('open').addClass('closed');
                }

                parent.element.show();
            }

            restoreInitialVisibility(searchIndex.children);
            makeZebra();
            return;
        }

        for (var parentId in searchIndex.parents) {
            var parent = searchIndex.parents[parentId];

            var parentVisible = parent.text.indexOf(query) != -1;
            var anyChildVisible = false;

            for (var i in parent.children) {
                var childId = parent.children[i];
                var child = searchIndex.children[childId];

                var childVisible = child.text.indexOf(query) != -1;
                parentVisible = parentVisible || childVisible;

                if (child.initialState == undefined) {
                    child.initialState = child.element.is(':visible');
                }

                anyChildVisible = anyChildVisible || childVisible;

                if (childVisible) {
                    child.element.show();
                } else {
                    child.element.hide();
                }
            }

            if (parent.initialState == undefined) {
                parent.initialState = parent.element.is(':visible');
            }

            if (parentVisible) {
                if (anyChildVisible) {
                    parent.element.removeClass('closed').addClass('open');
                } else {
                    parent.element.removeClass('open').addClass('closed');
                }

                parent.element.show();
            } else {
                parent.element.hide();
            }
        }

        makeZebra();
    });

    $('.filter > select').change(function() {
        window.location = $(this).children(':selected').val();
    });
});

function makeZebra() {
    var allLis = $('li:visible');
    allLis.not(':odd').removeClass('odd').addClass('even');
    allLis.not(':even').removeClass('even').addClass('odd');
}